Subject: [scim] SCIM 2.0 PATCH - modifying custom or enterprise schema attributes with missing "path"

From: "Karaimin, Aleyidin" <[email-masked]>
Date: Wed, 14 Nov 2018 13:00:40 +0000

Hello,
According to the RFC 7644-System for Cross-domain Identity Management: Protocol, section 3.5.2-Modifying with PATCH,

'The "path" attribute is
   OPTIONAL for "add" and "replace" and is REQUIRED for "remove"
'
Let's assume that in some case, "path" is not provided for add or replace operation. Is it possible to assign value to custom schema attribute (or extension Enterprise for User) ?.
Suppose we have the following bodies of PATCH Requests

Example 1:

{ "schemas":
       ["urn:ietf:params:scim:api:messages:2.0:PatchOp"],
     "Operations":[
       {
        "op":"add",
        "value":       {
               "urn:ietf:params:scim:schemas:extension:enterprise:2.0:User" : {
                               "employeeNumber" : "12345"
               },
               "nickname" : "simpleNickname"
                }
       }
    ]
}
Is the above example valid ? Can we assign custom attribute to corresponding value in "value" body ?

Example 2:
{ "schemas":
       ["urn:ietf:params:scim:api:messages:2.0:PatchOp"],
     "Operations":[
       {
        "op":"add",
        "value":       {
               "urn:ietf:params:scim:schemas:extension:enterprise:2.0:User:employeeNumber" : "12345",
               "nickname" : "simpleNickname"
                }
       }
    ]
}

If the Example 1 is valid, is it allowed to specify full attribute path in the "value" body ?

Thank you,
Aleydin Karaimin

---

From: Phil Hunt <[email-masked]>
Date: Wed, 14 Nov 2018 11:26:45 -0800

Aleydin,

Thanks for the interesting example.

IMO both examples are valid. 

A rule of thumb for me, is if you can understand it clearly, you should accept it.

If you are writing a client, be aware that there are lots of server implementations that aren’t as “robust” as they might be and may fail on this one.

Phil

Oracle Corporation, Cloud Security and Identity Architect
@independentid
www.independentid.com <http://www.independentid.com/>[email-masked] <mailto:[email-masked]>

> On Nov 14, 2018, at 5:00 AM, Karaimin, Aleyidin <[email-masked]> wrote:
> 
> Hello,
> ‘The "path" attribute is
> ’
> Let’s assume that in some case, “path” is not provided for add or replace operation. Is it possible to assign value to custom schema attribute (or extension Enterprise for User) ?.
> Is the above example valid ? Can we assign custom attribute to corresponding value in “value” body ?
>  
> Example 2:
> { "schemas":
> If the Example 1 is valid, is it allowed to specify full attribute path in the “value” body ?
>  
> Thank you,
> Aleydin Karaimin
>  
> _______________________________________________
> scim mailing list
> [email-masked] <mailto:[email-masked]>
> https://urldefense.proofpoint.com/v2/url?u=https-3A__www.ietf.org_mailman_listinfo_scim&d=DwICAg&c=RoP1YumCXCgaWHvlZYR8PZh8Bv7qIrMUB65eapI_JnE&r=na5FVzBTWmanqWNy4DpctyXPpuYqPkAI1aLcLN4KZNA&m=IM8g4xCE7ueFZYCMNifU_o_J4kgaWb4y8e5fPKIO2d0&s=xn2tQFGKNxirT3fsN6MPv5zSobvRJ7yDI6q237paKJM&e= <https://urldefense.proofpoint.com/v2/url?u=https-3A__www.ietf.org_mailman_listinfo_scim&d=DwICAg&c=RoP1YumCXCgaWHvlZYR8PZh8Bv7qIrMUB65eapI_JnE&r=na5FVzBTWmanqWNy4DpctyXPpuYqPkAI1aLcLN4KZNA&m=IM8g4xCE7ueFZYCMNifU_o_J4kgaWb4y8e5fPKIO2d0&s=xn2tQFGKNxirT3fsN6MPv5zSobvRJ7yDI6q237paKJM&e=>

---

From: "Karaimin, Aleyidin" <[email-masked]>
Date: Thu, 15 Nov 2018 09:16:15 +0000

Thank you for the fast response, Phil.

Regards,
Aleyidin

From: Phil Hunt <[email-masked]>
Sent: Wednesday, November 14, 2018 9:27 PM
To: Karaimin, Aleyidin <[email-masked]>
Cc: [email-masked]
Subject: Re: [scim] SCIM 2.0 PATCH - modifying custom or enterprise schema attributes with missing "path"

Aleydin,

Phil

Oracle Corporation, Cloud Security and Identity Architect
@independentid
www.independentid.com<http://www.independentid.com>
[email-masked]<mailto:[email-masked]>

On Nov 14, 2018, at 5:00 AM, Karaimin, Aleyidin <[email-masked]<mailto:[email-masked]>> wrote:

Hello,

‘The "path" attribute is

Example 1:

{ "schemas":

Example 2:
{ "schemas":

Thank you,
Aleydin Karaimin

_______________________________________________
scim mailing list
[email-masked]<mailto:[email-masked]>
https://urldefense.proofpoint.com/v2/url?u=https-3A__www.ietf.org_mailman_listinfo_scim&d=DwICAg&c=RoP1YumCXCgaWHvlZYR8PZh8Bv7qIrMUB65eapI_JnE&r=na5FVzBTWmanqWNy4DpctyXPpuYqPkAI1aLcLN4KZNA&m=IM8g4xCE7ueFZYCMNifU_o_J4kgaWb4y8e5fPKIO2d0&s=xn2tQFGKNxirT3fsN6MPv5zSobvRJ7yDI6q237paKJM&e=